<?php

namespace Ardent\UtilBundle\EntityBuilder;

use Symfony\Component\Console\Question\ChoiceQuestion;
use Symfony\Component\Console\Question\Question;

class EnumChoiceElement extends BaseElement
{
    public function getQuestion(): Question
    {
        return new ChoiceQuestion($this->getPrettyProperty(), array_map(fn($enum) => $enum->value, $this->enumClass::cases()));
    }

    public function __construct(
        string                  $property,
        private readonly string $enumClass,
    )
    {
        parent::__construct($property);
    }

    public function transformValue(mixed $value): mixed
    {
        return $this->enumClass::from($value);
    }
}